unit ULift2;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
   ScktComp;

type
  TPassanger = record
    id: String;
    StartFloor: Integer;
    EndFloor: Integer;
    StartTime: Integer;
    BlockTime: Integer;
    BackTime: Integer;
  end;

  TOneLift = record  // zaznam jednoho vytahu
    Level: Integer;
    Tolevel: Integer;
    DoorStatus: Byte;
    Height : Integer;
  end;


  TLift =  class   // trida na ovladani vyah
  public
    FClient: TClientSocket;
    FLevel: Integer;
    FLevels: Integer;
    FShafts: Integer;
    FList: TList;
    FPassangerList: TList;


    constructor create(Client: TClientSocket);
    procedure Connect;
    procedure Disconnect;
    procedure SendCmd(Cmd: String; Parameter: Integer); overload;
    procedure SendCmd(Cmd: String; Parameter: String); overload;
    procedure ReceiveData(Text: String);
    Procedure CreateOneLIfts;


    //prikazy
    procedure Speed(_Shaft, _Speed : Integer );
    destructor free;

    //udalosti
    procedure Jevlevelu(Shaft, Level: Integer);
    procedure NewPassanger(Id:String; StartFloor, EndFloor, StartTime, BlockTIme, BackTime: Integer);
    procedure DoLevelButtonUp(ToFloor: Integer);
    procedure DoLevelButtonDown(ToFloor: Integer);
  end;

var
  Lift: TLift;


implementation
Uses main;
{ Lift }

function GetParam(S:String; Index: Integer):String;
// ziska s textu paramter text je ve tvaru "param1 param2 paramN"
var Pocet,i: Integer;
begin
  Result := '';
  pocet := 1;
  S := S + ' ';

  while Length(S) > 0 do
  Begin
    if Pocet = Index then
    Begin
      result := Copy(S,1,pos(' ',S)-1);
      break;
    end;
    pocet := pocet+ 1;
    Delete(S,1,pos(' ',S));
  end;
end;






procedure TLift.Connect;
begin
  FClient.Open;
end;

constructor TLift.create(Client: TClientSocket);
begin
  FLevel := 0;
  FShafts := 0;
  Flevels := 0;
  FClient := Client;
end;

procedure TLift.Disconnect;
begin
  FClient.Close;
end;

destructor TLift.free;
begin

end;

procedure TLift.SendCmd(Cmd: String; Parameter: Integer);
// posila prikaz
Var
  Zprava, Return: String;
begin
  Zprava := Cmd + ' ' + IntToStr(Parameter) +#13+#10;
  FClient.Socket.SendText(Zprava);
end;



procedure TLift.ReceiveData(Text: String);
// vykonava reakce na udalosti
var Row: String;


  function GetRow(var S:String):String;
  // ziska z prichozich zprav jen jeden radek
  var i: integer;
  Begin
    Result := '';
    For i := 1 to length(S) do
    begin
      if s[i] = #13 then
      begin
        result := Copy(S,1,i-1);
        Delete(S,1,i+1);
        break;
      end;
    end;

  end;


begin
  Form1.Memo1.Lines.Add('"'+Text + '"');
  Row := GetRow(Text);
  while Row <> '' do
  begin
    if Pos('levelbuttonup',Row) > 0 then
      DOLevelButtonUP(StrToint(GetParam(Row,2)))
    else
    if Pos('levelbuttondn',Row) > 0 then
      DOLevelButtonDown(StrToint(GetParam(Row,2)))
    else
    if Pos('levels',Row) > 0 then
      FLevels := StrToint(GetParam(Row,2))
    else
    if Pos('shafts',Row) > 0 then
    Begin
      FShafts := StrToint(GetParam(Row,2));
      CreateOneLifts;
    end
    else
    if (Pos('closed', Row) > 0)and(FShafts > 0) then
      TOneLift(FList.Items[StrToInt(GetParam(Row,2))]^).DoorStatus := 0
    else
    if Pos('level', Row ) > 0 then
      JeVLevelu(StrToInt(GetParam(Row,2)),StrToint(GetParam(Row,3)))
    else
    if Pos('meter',Row) > 0 then   // uklada hodnotu vysky do urciteho vytahu
      TOneLift(FList.Items[StrToInt(GetParam(Row,2))]^).Height := StrToInt(GetParam(Row,3));
    if Pos('cabinbutton',Row) > 0 then
      //-
    else
    if Pos('newpas',Row) > 0 then
      NewPassanger(GetParam(Row,2),StrToInt(GetParam(Row,3)),StrToInt(GetParam(Row,4)),
      StrToInt(GetParam(Row,5)),StrToInt(GetParam(Row,6)),StrToInt(GetParam(Row,7)));





    Row := GetRow(Text);
  end;

end;

procedure TLift.SendCmd(Cmd, Parameter: String);
Var
  Zprava, Return: String;
begin
  Zprava := Cmd + ' ' + Parameter + #13+#10;
  FClient.Socket.SendText(Zprava);
end;

procedure TLift.Speed(_Shaft, _Speed: Integer);
// spusit prikaz speed
begin
  SendCmd('speed', IntToStr(_Shaft) + ' ' + IntToStr(_Speed));
end;




procedure TLift.CreateOneLIfts;
// vytvori objekty pro kazdou sachtu
var i: integer;
    OneLift: TOneLift;
    POneLift: ^TOneLift;
begin
  if FList <> nil then
      exit;
  Flist := TList.Create;
  for i := 1 to FShafts do
  begin
    new(POneLift);
    POneLIft^.DoorStatus := 0;
    POneLift^.Height := 0;
    POneLift^.Level := 0;
    POneLift^.ToLevel := 0;
    Flist.Add(POneLift);
  end;
end;

procedure TLift.Jevlevelu(Shaft, Level: Integer);
// zastavi vytah kdyz je v spravnem patre
begin
  if Level = TOneLIft(FList.Items[Shaft]^).ToLevel then
    Speed(Shaft, 0);
  if Level + 1 = TOneLIft(FList.Items[Shaft]^).ToLevel then
    Speed(Shaft, -100);

end;

procedure TLift.NewPassanger(Id: String; StartFloor, EndFloor, StartTime,
  BlockTIme, BackTime: Integer);
var i: integer;
    Pas: TPassanger;
    PPas: ^TPassanger;
begin
  if FPassangerList = nil then
    exit;
  new(PPas);
  Pas := PPas^;
  Pas.id := id;
  Pas.StartFloor := StartFloor;
  Pas.EndFloor := EndFloor;
  pas.StartTime := StartTime;
  Pas.BlockTime := BlockTime;
  Pas.BackTime := BackTime;
  FPassangerlist.Add(PPas);
end;

procedure TLift.DoLevelButtonUp(ToFloor: Integer);
var i: integer;
begin
  for i := 0 to Flist.Count - 1 do
  begin
    if TOneLIft(FList.Items[i]^).Level < ToFloor then
    begin
      Speed(i,-1000);
      TOneLIft(FList.Items[i]^).ToLevel := ToFloor;
      break;
    end;
  end;
end;

procedure TLift.DoLevelButtonDown(ToFloor: Integer);
var i: integer;
begin
  for i := 0 to Flist.Count - 1 do
  begin
    if TOneLIft(FList.Items[i]^).Level > ToFloor then
    begin
      Speed(i,1000);
      SendCmd('indinon',IntToStr(ToFloor));
      TOneLIft(FList.Items[i]^).ToLevel := ToFloor;
      break;
    end;
    if TOneLIft(FList.Items[i]^).Level < ToFloor then
    begin
      Speed(i,-1000);
      SendCmd('indiupon',IntToStr(ToFloor));
      TOneLIft(FList.Items[i]^).ToLevel := ToFloor;
      break;
    end;
  end;
end;

end.
